# Lixp - A lisp implementation by C

## Description

This is a lisp implementation guided by [buildyourownlisp](http://www.buildyourownlisp.com/contents). 

Video on [Youtube](https://youtu.be/tpd2qf2y1Ko).

## Compile

Just use `make`, but `libeditline` is required. 
```
$ make
```

## Launch 

```
$ ./lixp
```

## Usage

Type in the interactive console. You can careate and interact the variables, use some built-in functions and define your own functions.

### arthmetic operation
```
lixp> + 1 (* 2 8)
17 
```
### define a function
```
(def {hello} "Hello World")
```
### some built-in function
`list`,`head`, `join`, `tail`
```
lixp> list 1 2 3 4
{1 2 3 4}
lixp> head {1 2 4}
{1}
lixp> join {1 2} {3 4}
{1 2 3 4}
lixp> tail {1 2 3 4}
{2 3 4}
```
### if statement
```
lixp> def {x y} 100 200
ok    
lixp> if (== x y) {+ x y} {- x y}
-100  
```
### comment 
```
; this is a commment.
```

## Description of the files

### util.c/h
Defined some utilities
### shared.c/h
Global shared variables for setting up the parser.
### mpc.c/h
3rd-party lib for tokenizing input, defining a parser.
### lval.c/h
Data structres and functions for `lval`, which represents the minimal unit in the process of the computation of lixp.
### lang.c/h
implementation of the tokenizer and the parser of the lixp.
### functions.c/h
implementation of the built-in functions.

## TODO

* enable user to define a function
* garbage collector
* native type, not using `long ` in C
* user defined type
* OS interaction, i.e. file system